angular
	.module('gu.controller')
	.controller('DetailJournalCtrl', function ($scope, $rootScope, $stateParams, $ionicHistory, $ionicLoading, $ionicScrollDelegate, $timeout, ApiService) {
		$scope.data = {
			id: $stateParams.id,
			news: [],
			journal: {},
			totalPage: 1,
			pageNo: 1,
			scrollPos: 0
		};

		// $rootScope.nativeAd = {
		// 	'title': '神奇优惠券',
		// 	'desc': '淘宝内部优惠券，逛边赚钱',
		// 	'show': ['http://up-app.image.alimmdn.com/gg/recruit/first/migu706x396.jpg'],
		// 	'click': true,
		// }

		$rootScope.$on('FOCUS_CLICKED', function (event, data) {
			if ($scope.data.journal.JID == data.journalID) {
				if (data.addFlag) {
					$scope.data.journal.focuses_count++;
				} else {
					$scope.data.journal.focuses_count--;
				}
			}
		});

		$rootScope.$on('LIKE_CLICKED', function (event, data) {
			for (var index = 0; index < $scope.data.news.length; index++) {
				if ($scope.data.news[index].Nid == data.newsID)
					break;
			}

			if (index < $scope.data.news.length) {
				if (data.addFlag) {
					$scope.data.news[index].likes_count++;
				} else {
					$scope.data.news[index].likes_count--;
				}
			}
		})

		$rootScope.$on('HEART_CLICKED', function (event, data) {

			for (var index = 0; index < $scope.data.news.length; index++) {
				if ($scope.data.news[index].Nid == data.newsID)
					break;
			}

			if (index < $scope.data.news.length) {
				if (data.addFlag) {
					$scope.data.news[index].hearts_count++;
				} else {
					$scope.data.news[index].hearts_count--;
				}
			}

		})

		$scope.goBack = function () {
			$rootScope.$ionicGoBack();
		}

		$scope.doRefresh = function () {
			init();
			$scope.$broadcast('scroll.refreshComplete');
		}

		$scope.getScrollPosition = function () {
			$timeout(function () {
				$scope.data.scrollPos = $ionicScrollDelegate.getScrollPosition().top;
			});
		}

		$scope.loadMoreNews = function () {
			ApiService.loadNewsByJournal({
				journalID: $scope.data.id,
				pageNo: $scope.data.pageNo + 1
			}).then(function (response) {
				$scope.data.totalPage = response.data.totalPage;
				$scope.data.pageNo = response.data.pageNo;
				for (var i = 0; i < response.data.news.length; i++) {
					$scope.data.news.push(response.data.news[i]);
				}
			}).catch(function (error) {
			}).finally(function () {
				$scope.$broadcast('scroll.infiniteScrollComplete');
			})
		}

		init();

		function init() {
			loadJournal();
			loadNews();
		}

		function loadJournal() {
			$ionicLoading.show({
				template: '加载中...',
				showBackdrop: true,
			});
			ApiService.loadJournal({
				journalID: $scope.data.id
			}).then(function (response) {
				$scope.data.journal = response.data.journal;
			}).catch(function (error) {
			}).finally(function () {
				$ionicLoading.hide();
			})
		}

		function loadNews() {
			$ionicLoading.show({
				template: '加载中...',
				showBackdrop: true,
			});
			ApiService.loadNewsByJournal({
				journalID: $scope.data.id,
				pageNo: 1
			}).then(function (response) {
				$scope.data.totalPage = response.data.totalPage;
				$scope.data.pageNo = response.data.pageNo;
				$scope.data.news = response.data.news;
			}).catch(function (error) { }).finally(function () {
				$ionicLoading.hide();
			})
		}
	})

	.controller('DetailNewsCtrl', function ($scope, $rootScope, $stateParams, $ionicHistory, $ionicLoading, ApiService) {
		console.log('文章详细页');

		$scope.data = {
			id: $stateParams.id, // 文章ID
			journal: {},
			topNews: {},
			recentNews: [],

			totalPage: 1,
			pageNo: 0
		};

		$scope.$on('FOCUS_CLICKED', function (event, data) {
			if ($scope.data.journal.JID == data.journalID) {
				if (data.addFlag) {
					$scope.data.journal.focuses_count++;
				} else {
					$scope.data.journal.focuses_count--;
				}
			}
		});

		$scope.$on('LIKE_CLICKED', function (event, data) {
			if ($scope.data.topNews.Nid == data.newsID) {
				if (data.addFlag) {
					$scope.data.topNews.likes_count++;
				} else {
					$scope.data.topNews.likes_count--;
				}
			}
		})

		$scope.$on('HEART_CLICKED', function (event, data) {
			if ($scope.data.topNews.Nid == data.newsID) {
				if (data.addFlag) {
					$scope.data.topNews.hearts_count++;
				} else {
					$scope.data.topNews.hearts_count--;
				}
			}
			else {
				for (var index = 0; index < $scope.data.recentNews.length; index++) {
					if ($scope.data.recentNews[index].Nid == data.newsID)
						break;
				}

				if (index < $scope.data.recentNews.length) {
					if (data.addFlag) {
						$scope.data.recentNews[index].hearts_count++;
					} else {
						$scope.data.recentNews[index].hearts_count--;
					}
				}
			}

		})


		$scope.goBack = function () {
			$rootScope.$ionicGoBack();
		}

		$scope.loadMoreRecentNews = function () {
			ApiService
				.loadNewsByJournal({
					journalID: $scope.data.journal.JID,
					pageNo: $scope.data.pageNo + 1
				})
				.then(function (response) {
					$scope.data.totalPage = response.data.totalPage;
					$scope.data.pageNo = response.data.pageNo;
					for (var i = 0; i < response.data.news.length; i++) {
						$scope.data.recentNews.push(response.data.news[i]);
					}
				})
				.catch(function (error) {
				})
				.finally(function () {
					$scope.$broadcast('scroll.infiniteScrollComplete');
				})
		}

		init();

		function init() {
			loadNews();
		}

		function loadNews() {
			$ionicLoading.show({
				template: '加载中...',
				showBackdrop: true,
			});
			ApiService
				.loadNews({
					newsID: $scope.data.id
				})
				.then(function (response) {
					if (response.data) {
						$scope.data.topNews = response.data.news;
						$scope.data.journal = response.data.journal;
					}
				})
				.catch(function (error) {
				})
				.finally(function () {
					$ionicLoading.hide();
				})
		}
	})
