angular
  .module('gu.controller')
  .controller('HomeCtrl', function ($scope, $rootScope, $state, $location, $ionicHistory, $ionicLoading, $ionicScrollDelegate, LocalService, ApiService, $ionicNativeTransitions, $ionicSlideBoxDelegate) {
    $ionicNativeTransitions.enable(true);
    loadBannerAd(); //for ad

    $scope.data = {
      categoryIndex: -1,
      categories: [],

      topNews: [],
      news: [],
      totalPage: 1,
      pageNo: 1
    }

    // $rootScope.nativeAd = {
    // 	'title': '神奇优惠券',
    // 	'desc': '淘宝内部优惠券，逛边赚钱',
    // 	'show': ['http://up-app.image.alimmdn.com/gg/recruit/first/migu706x396.jpg'],
    // 	'click': true,
    // }

    $rootScope.$on('FOCUS_CLICKED', function (event, data) {
      for (var index = 0; index < $scope.data.topNews.length; index++) {
        if ($scope.data.topNews[index].journal.JID == data.journalID) {
          if (data.addFlag) {
            $scope.data.topNews[index].journal.focuses_count++;
          } else {
            $scope.data.topNews[index].journal.focuses_count--;
          }
        }
      }
    });

    $scope.search = function () {
      $state.go('search', { keyword: $scope.data.keyword });
      $scope.data.keyword = '';
    }

    /* $rootScope.$on('LIKE_CLICKED', function(event, data) {
       for (var index = 0; index < $scope.data.topNews.length; index++) {
         if ($scope.data.topNews[index].Nid == data.newsID)
           break;
       }
       if (index < $scope.data.topNews.length) {
         if (data.addFlag) {
           $scope.data.topNews[index].likes_count ++;
         } else {
           $scope.data.topNews[index].likes_count --;
         }
       }
     })
   */
    $rootScope.$on('HEART_CLICKED', function (event, data) {
      for (var index = 0; index < $scope.data.topNews.length; index++) {
        if ($scope.data.topNews[index].Nid == data.newsID)
          break;
      }

      if (index < $scope.data.topNews.length) {
        if (data.addFlag) {
          $scope.data.topNews[index].hearts_count++;
        } else {
          $scope.data.topNews[index].hearts_count--;
        }
      }
    })

    $scope.doRefresh = function () {
      init();
      $scope.$broadcast('scroll.refreshComplete');
      loadBannerAd(); //for ad
    };

    $scope.changeCategory = function (index) {
      if ($scope.data.categoryIndex == index) {
        return;
      }
      $scope.data.categoryIndex = index;
      if (index <= 2) {
        $ionicScrollDelegate.$getByHandle('homeCategoryScroll').scrollTop();
      } else {
        $location.hash('home-category-' + (index - 2));
        $ionicScrollDelegate.$getByHandle('homeCategoryScroll').anchorScroll(true);
      }
      loadTopNews();
    }

    $scope.loadMore = function () {
      var categoryID = currentCategoryID();
      ApiService
        .loadAllTopNews({
          pageNo: $scope.data.pageNo + 1,
          categoryID: categoryID
        })
        .then(function (response) {
          $scope.data.totalPage = response.data.totalPage;
          $scope.data.pageNo = response.data.pageNo;

          for (var i = 0; i < response.data.news.length; i++) {
            var topNews = response.data.news[i];
            $scope.data.topNews.push(topNews);
          }
        })
        .catch(function (response) {
        })
        .finally(function () {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    }


    init();

    function init() {
      loadCategory();
      loadTopNews();
    }

    // 加载页面显示信息
    function loadTopNews() {
      var categoryID = currentCategoryID();

      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true
      });

      // 加载轮播图内容
      ApiService
        .loadAllTopNews({
          pageNo: 1,
          categoryID: categoryID
        })
        .then(function (res) {
          $scope.data.slideNews = res.data.news;
          // 初始化滑动框
          $ionicSlideBoxDelegate.update();
          // 循环轮播
          $ionicSlideBoxDelegate.loop(true);
        })
        .catch(function (error) {
        })

      // 加载页面里内容
      ApiService
        .loadAllTopNews({
          pageNo: 2,
          categoryID: categoryID
        })
        .then(function (response) {

          $scope.data.totalPage = 0;
          $scope.data.pageNo = 0;
          $scope.data.topNews = [];

          setTimeout(function(){
            $scope.data.totalPage = response.data.totalPage;
            $scope.data.pageNo = response.data.pageNo;
            $scope.data.topNews = response.data.news;
            $scope.$apply();
          }, 0)

        })
        .catch(function (error) {
        })
        .finally(function () {
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
          $ionicLoading.hide();
        });
    }

    // 加载tab栏信息
    function loadCategory() {
      ApiService
        .loadCategories()
        .then(function (response) {
          var categories = [];
          response.data.forEach((v, k) => {
            if (v.sName != '历史') categories.push(response.data[k]);
          });
          if (!categories.length) {
            $ionicLoading.hide();
            return;
          }
          LocalService
            .storeCategories(categories)
            .then(function (response) {
              $scope.data.categories = categories;
            })
            .catch(function (error) {
              //alert(JSON.stringify(error));
            })
        })
        .catch(function (error) {
          //alert("2:" + JSON.stringify(error));
        });
    }

    // 点击索引，跳到指定的
    $scope.toSlideIndex = function (index) {
      $scope.activeIndex = index;
    }

    function currentCategoryID() {
      return ($scope.data.categoryIndex == -1) ? 0 : $scope.data.categories[$scope.data.categoryIndex].sid;
    }
  })
