angular
  .module('gu.controller')
  .controller('JournalCtrl', function ($scope, $rootScope, $state, $ionicHistory, $ionicScrollDelegate, $location, $ionicLoading, LocalService, ApiService) {
    loadChapingAd(); //for ad
    console.log('小刊页');
    $scope.data = {
      categories: LocalService.categories(),
      categoryIndex: -1,
      latestNews: {},
      recentJournals: [],
      keyword: '恋爱',

      totalPage: 1,
      pageNo: 1,
      topNews: [],
      news: [],
      hotJournals: [],
      searchResults: {
        news: [],
        journals: []
      },
      searchFinished: true,

      journalTotalPage: 2,
      journalPageNo: 1,
      newsTotalPage: 2,
      newsPageNo: 1,

      firstFilterChange: true

    };

    $rootScope.$on('FOCUS_CLICKED', function (event, data) {
      for (var index = 0; index < $scope.data.recentJournals.length; index++) {
        if ($scope.data.recentJournals[index].JID == data.journalID)
          break;
      }
      if (index < $scope.data.recentJournals.length) {
        if (data.addFlag) {
          $scope.data.recentJournals[index].focuses_count++;
        } else {
          $scope.data.recentJournals[index].focuses_count--;
        }
      }
    });

    $scope.doRefresh = function () {
      console.log('上啦刷新');
      init();
      $scope.$broadcast('scroll.refreshComplete');
    };

    $scope.search = function () {
      if (!$scope.data.keyword) return;
      $state.go('search', { keyword: $scope.data.keyword });
      $scope.data.keyword = '';
    }

    $scope.loadMoreJournals = function () {
      var categoryID = currentCategoryID();
      if (categoryID) {
        ApiService
          .loadJournalsByCategory({
            categoryID: categoryID,
            pageNo: $scope.data.pageNo + 1
          })
          .then(function (response) {
            $scope.data.totalPage = response.data.totalPage;
            $scope.data.pageNo = response.data.pageNo;

            for (var i = 0; i < response.data.journals.length; i++) {
              $scope.data.hotJournals.push(response.data.journals[i]);
            }
          })
          .catch(function (error) {
          })
          .finally(function () {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
      } else {
        ApiService
          .loadHotJournals({
            pageNo: $scope.data.pageNo + 1
          })
          .then(function (response) {
            $scope.data.totalPage = response.data.totalPage;
            $scope.data.pageNo = response.data.pageNo;

            for (var i = 0; i < response.data.journals.length; i++) {
              var journals = response.data.journals[i];
              $scope.data.hotJournals.push(journals);
            }
          })
          .catch(function (response) {
          })
          .finally(function () {
            $scope.$broadcast('scroll.infiniteScrollComplete');
          })
      }

    }

    init();

    function init() {
      $scope.data.categories = LocalService.categories();
      loadLatestNews();
      loadHotJournals();
    }

    function loadLatestNews() {
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadLatestNews()
        .then(function (response) {
          $scope.data.latestNews = response.data.news;
        })
        .catch(function (error) {
        })
        .finally(function () {
          $ionicLoading.hide();
        })
    }

    function loadHotJournals() {
      var categoryID = currentCategoryID();
      if (categoryID) {
        ApiService
          .loadJournalsByCategory({
            categoryID: $scope.data.categories[$scope.data.categoryIndex].sid,
            pageNo: 1
          })
          .then(function (response) {
            $scope.data.totalPage = response.data.totalPage;
            $scope.data.pageNo = response.data.pageNo;
            $scope.data.hotJournals = response.data.journals;
          })
          .catch(function (error) {
          })
          .finally(function () {
            $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
            $ionicLoading.hide();
          })
      } else {
        ApiService
          .loadHotJournals({
            pageNo: 1
          })
          .then(function (response) {
            $scope.data.totalPage = response.data.totalPage;
            $scope.data.pageNo = response.data.pageNo;
            $scope.data.hotJournals = response.data.journals;
          })
          .catch(function (response) {
          })
          .finally(function (response) {
          })
      }

    }


    $scope.changeCategory = function (index) {
      if ($scope.data.categoryIndex == index) {
        return;
      }
      $scope.data.categoryIndex = index;
      if (index <= 2) {
        $ionicScrollDelegate.$getByHandle('categoryScroll').scrollTop();
      } else {
        $location.hash('category-' + (index - 2));
        $ionicScrollDelegate.$getByHandle('categoryScroll').anchorScroll(true);
      }
      loadHotJournals();
    }

    function currentCategoryID() {
      return ($scope.data.categoryIndex == -1) ? 0 : $scope.data.categories[$scope.data.categoryIndex].sid;
    }

    //banner
    $scope.goBack = function () {
      $rootScope.$ionicGoBack();
    }

    $scope.loadMoreSearchNews = function () {
      $scope.data.searchFinished = false;
      ApiService
        .loadSearchNews({
          keyword: $scope.data.keyword,
          pageNo: $scope.data.newsPageNo + 1
        })
        .then(function (response) {
          $scope.data.newsTotalPage = response.data.totalPage;
          $scope.data.newsPageNo = response.data.pageNo;
          for (var i = 0; i < response.data.news.length; i++) {
            $scope.data.searchResults.news.push(response.data.news[i]);
          }
        })
        .catch(function (response) {
        })
        .finally(function (response) {
          $ionicLoading.hide();
          $scope.data.searchFinished = true;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    }

    init1();

    function init1() {
      $scope.data.searchFinished = false;
      // 文章
      $ionicLoading.show({
        template: '加载中...',
        showBackdrop: true,
      });
      ApiService
        .loadSearchNews({
          keyword: $scope.data.keyword,
          pageNo: 1
        })
        .then(function (response) {
          $scope.data.newsTotalPage = response.data.totalPage;
          $scope.data.newsPageNo = response.data.pageNo;
          $scope.data.searchResults.news = response.data.news;
        })
        .catch(function (response) {
        })
        .finally(function (response) {
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
          $ionicLoading.hide();
          $scope.data.searchFinished = true;
        })

    }

  })




